# 기여자 서약 행동 강령

## 우리의 서약
우리는 회원, 기여자, 그리고 리더로서 나이, 신체 크기, 보이거나 보이지 않는 장애, 인종, 성 특성, 성 정체성과 표현, 경험 수준, 교육, 사회경제적 지위, 국적, 외모, 인종, 종교, 성적 정체성과 성향에 관계없이 모든 사람이 괴롭힘 없이 우리 커뮤니티에 참여할 수 있도록 할 것을 서약합니다.

우리는 개방적이고, 환영하며, 다양하고, 포용적이며, 건강한 커뮤니티에 기여하는 방식으로 행동하고 상호 작용할 것을 서약합니다.

## 우리의 기준
우리 커뮤니티에 긍정적인 환경을 조성하는 행동의 예는 다음과 같습니다:

* 다른 사람들에게 공감과 친절을 보여주는 것
* 다양한 의견, 관점, 경험을 존중하는 것
* 건설적인 피드백을 주고 우아하게 수용하는 것
* 우리의 실수에 대해 책임을 지고, 영향을 받은 사람들에게 사과하며, 그 경험으로부터 배우는 것
* 개인으로서뿐만 아니라 전체 커뮤니티에 무엇이 가장 좋은지에 집중하는 것

받아들일 수 없는 행동의 예는 다음과 같습니다:

* 성적 언어 또는 이미지 사용, 성적 관심 또는 접근
* 트롤링, 모욕적이거나 경멸적인 댓글, 개인적 또는 정치적 공격
* 공개적 또는 사적인 괴롭힘
* 물리적 또는 이메일 주소와 같은 다른 사람의 개인 정보를 명시적인 허락 없이 공개하는 것
* 전문적인 환경에서 부적절하다고 간주될 수 있는 기타 행위

## 집행 책임
커뮤니티 리더는 우리의 기준을 명확히 하고 집행할 책임이 있으며, 부적절하다고 판단되는 행동에 대해 적절하고 공정한 시정 조치를 취할 것입니다.

커뮤니티 리더는 이 행동 강령에 부합하지 않는 댓글, 커밋, 코드, 위키 수정, 이슈 및 기타 기여를 삭제, 편집 또는 거부할 권리와 책임이 있으며, 적절한 경우 조정 결정의 이유를 전달할 것입니다.

## 적용 범위
이 행동 강령은 모든 커뮤니티 공간 내에서 적용되며, 개인이 공식적으로 커뮤니티를 대표하는 공공 장소에서도 적용됩니다. 커뮤니티를 대표하는 예로는 공식 이메일 주소 사용, 공식 소셜 미디어 계정을 통한 게시, 온라인 또는 오프라인 이벤트에서 임명된 대표로 활동하는 경우 등이 있습니다.

## 집행
학대, 괴롭힘 또는 기타 받아들일 수 없는 행동 사례는 Contact method에서 집행 책임이 있는 커뮤니티 리더에게 보고할 수 있습니다. 모든 불만은 신속하고 공정하게 검토되고 조사될 것입니다.

모든 커뮤니티 리더는 사건 보고자의 프라이버시와 안전을 존중할 의무가 있습니다.

### 집행 지침
커뮤니티 리더는 이 행동 강령을 위반한 행위의 결과를 결정할 때 다음 커뮤니티 영향 지침을 따를 것입니다:

#### 시정
커뮤니티 영향: 부적절한 언어 사용 또는 커뮤니티에서 전문적이지 않거나 환영받지 못하는 것으로 간주되는 기타 행동.

결과: 커뮤니티 리더로부터 사적인 서면 경고를 받으며, 위반 행위의 성격과 그 행동이 부적절한 이유에 대한 설명을 제공합니다. 공개 사과를 요청할 수 있습니다.

#### 경고
커뮤니티 영향: 단일 사건 또는 일련의 행동을 통한 위반.
결과: 지속적인 행동에 대한 결과와 함께 경고를 받습니다. 특정 기간 동안 관련된 사람들과의 상호 작용, 특히 행동 강령을 집행하는 사람들과의 불필요한 상호 작용을 금지합니다. 이러한 조건을 위반하면 일시적 또는 영구적 금지 조치로 이어질 수 있습니다.

#### 일시적 금지
커뮤니티 영향: 커뮤니티 기준을 심각하게 위반한 경우, 지속적인 부적절한 행동 포함.
결과: 특정 기간 동안 커뮤니티와의 모든 상호 작용 또는 공개 커뮤니케이션에서 일시적 금지를 받습니다. 이 기간 동안 관련된 사람들과의 공개적 또는 사적인 상호 작용이 허용되지 않습니다. 이러한 조건을 위반하면 영구적 금지 조치로 이어질 수 있습니다.

#### 영구적 금지
커뮤니티 영향: 커뮤니티 기준을 지속적으로 위반하는 패턴을 보이는 경우, 개인에 대한 괴롭힘 또는 집단에 대한 공격 또는 비방을 포함.
결과: 커뮤니티 내에서 모든 공개적 상호 작용에서 영구적으로 금지됩니다.

## 출처
이 행동 강령은 Contributor Covenant, version 2.0을 기반으로 작성되었습니다. 원본은 https://www.contributor-covenant.org/version/2/0/code_of_conduct.html에서 확인할 수 있습니다.

커뮤니티 영향 지침은 Mozilla의 행동 강령 집행 사다리에서 영감을 받았습니다.

이 행동 강령에 대한 일반적인 질문에 대한 답변은 https://www.contributor-covenant.org/faq에서 확인할 수 있습니다. 번역본은 https://www.contributor-covenant.org/translations에서 확인할 수 있습니다.